; 
    include \masm32\include\masm32rt.inc
; 
.686p

comment * -----------------------------------------------------
                     Build this console app with
                  "MAKEIT.BAT" on the PROJECT menu.
        ----------------------------------------------------- *

    .data?
      value dd ?

    .data
      g_priorityClass textequ <REALTIME_PRIORITY_CLASS>

      ;item dd 0
      g_tallyBucketSize equ 256
      align 16
      REPEAT 2*g_tallyBucketSize
        dd 0
      ENDM
    .code

start:
   
; 
    invoke GetCurrentProcess
    invoke SetPriorityClass, eax, g_priorityClass
    invoke GetCurrentThread
    invoke SetThreadPriority, eax, THREAD_PRIORITY_TIME_CRITICAL
    invoke Sleep, 0
    call main
   ; inkey
    exit

; 

main proc
    call init_spinup
    call init_spinup
    call init_spinup
    call init_spinup
    call init_spinup
    call init_spinup
    call init_spinup
    call init_spinup
    call init_spinup
    call init_spinup
    call init_spinup
    call init_spinup
    call init_spinup
    call init_spinup
    call init_spinup
    call init_spinup
    cls
    mov ecx, 1000
l:
    call do_sample_run
    dec ecx
    jns l
    ret
main endp
    
do_sample_run proc
    push ecx
    invoke Sleep,0
    call spinup
    
    mov ecx, 1000
l:
    push ecx
    call timeit
    pop ecx
    dec ecx
    jns l
    pop ecx
    ret
do_sample_run endp

;; Does not visibly change any registers.
;; Simply spins up the CPU in preperation of "real" timing tests.
init_spinup proc
    push ecx
    mov ecx, 10000000
l:
    dec ecx
    jns l
    pop ecx
    ret
init_spinup endp


;; Does not visibly change any registers.
;; Simply spins up the CPU in preperation of "real" timing tests.
spinup proc
    push ecx
    mov ecx, 100000
l:
    dec ecx
    jns l
    pop ecx
    ret
spinup endp



align 16
timeit proc
; warmup
    xor eax, eax
    cpuid
    xor eax, eax
    cpuid
    xor eax, eax
    cpuid
    xor eax, eax
    cpuid
    xor eax, eax
    cpuid
    xor eax, eax
    cpuid
    rdtsc 
    ; now go for real!
    xor eax, eax
    cpuid
    rdtsc
    push eax
    push edx
    call testit
    xor eax, eax
    cpuid
    rdtsc
    push eax
    push edx
    call print_runtime
    ret

timeit endp

;;;;;;;;; code under test should go here! ;;;;;;;;;
testit proc
    ret
testit endp

print_runtime proc
    pop esi
    pop edx
    pop eax
    pop ecx
    ;sub edx, ecx
    cmp ecx, edx
    jne wraparound
    pop ecx
    sub eax, ecx
    print ustr$(eax)
    print " ",13,10
    push esi
    ret
wraparound:
    pop ecx
    push esi
    ret
    
print_runtime endp
; 

end start
